extends KinematicBody

# export variables
export(NodePath) var outline_path
export(bool) var card_door
export(int) var door_lvl

# const
const OPENING_SPEED = 50

# private members
var _startingRotY : int
var _isMoving = false
var _isOpening = false
var _degrees = 0

# Called when the node enters the scene tree for the first time.
func _ready():
	_startingRotY = global_transform.basis.get_euler().y

# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	if _isMoving:
		door_move(delta)

# called by player to interact with this scene
func do_interact(var player):
	if card_door:
		if player.keycard_lvl >= door_lvl:
			_isMoving = true
			_isOpening = !_isOpening
		else:
			print("keycard level too low")
	elif player.key_chain.has(door_lvl) or door_lvl == 0:
		_isMoving = true
		_isOpening = !_isOpening
	else:
		print("you don't have the right key")

# opens or closes the door
func door_move(delta):
	if _isOpening:
		if _degrees < 100:
			_degrees += OPENING_SPEED * delta
		else:
			_degrees = 100
			_isMoving = false
	else:
		if _degrees > 0:
			_degrees -= OPENING_SPEED * delta
		else:
			_degrees = 0
			_isMoving = false
	rotate_y(_degrees * PI/180 - global_transform.basis.get_euler().y + _startingRotY)
